# collibra-assessments_100
This API allows you to interact with the Assessments application in a programmatic way and perform actions such as retrieving data from conducted assessments or triggering new assessments.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import collibra_assessments 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import collibra_assessments
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import collibra_assessments
from collibra_assessments.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: basicAuth
configuration = collibra_assessments.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = collibra_assessments.AssessmentsApi(collibra_assessments.ApiClient(configuration))
body = collibra_assessments.ConductAssessmentRequest() # ConductAssessmentRequest | 

try:
    # Conduct an assessment
    api_response = api_instance.conduct_assessment(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AssessmentsApi->conduct_assessment: %s\n" % e)
# Configure HTTP basic authorization: basicAuth
configuration = collibra_assessments.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = collibra_assessments.AssessmentsApi(collibra_assessments.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | The ID of the assessment.

try:
    # Retrieve an assessment by ID
    api_response = api_instance.get_assessment(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AssessmentsApi->get_assessment: %s\n" % e)
# Configure HTTP basic authorization: basicAuth
configuration = collibra_assessments.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = collibra_assessments.AssessmentsApi(collibra_assessments.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | The ID of the assessment review asset.

try:
    # Retrieve an assessment by assessment review ID
    api_response = api_instance.get_assessment_by_assessment_review(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AssessmentsApi->get_assessment_by_assessment_review: %s\n" % e)
# Configure HTTP basic authorization: basicAuth
configuration = collibra_assessments.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = collibra_assessments.AssessmentsApi(collibra_assessments.ApiClient(configuration))
name = 'name_example' # str | The name of the assessment.   The value is case-insensitive and it returns results that contain this value.  (optional)
status = 'status_example' # str | The status of the assessment.   Possible values are: `DRAFT`, `SUBMITTED`, `COMPLETED` or `OBSOLETE`. The value is case-insensitive. An invalid value results in an error response.  (optional)
last_modified_from = '2013-10-20T19:20:30+01:00' # datetime | The date and time that defines the start of the period when the assessment was last updated, including this timestamp. (optional)
last_modified_until = '2013-10-20T19:20:30+01:00' # datetime | The date and time that defines the end of the period when the assessment was last updated, excluding this timestamp. (optional)
template_id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | The ID of the template. (optional)
template_version = 'template_version_example' # str | The version of the template.   Use `LATEST` to retrieve assessments that are on the latest version of a particular `templateId`. For other values, it returns results that have an exact match.  (optional)
asset_id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | The ID of the asset the assessment relates to. (optional)
limit = 10 # int | The maximum number of resources to retrieve.  If not set, the default limit of `10` is be used. The maximum value for this parameter is `50`.  (optional) (default to 10)
cursor = 'cursor_example' # str | The cursor pointing to the first resource to be included in the response. This cursor cannot be created and must have been extracted from a response returned by a previous API call.  If this parameter is missing, the API returns the resources starting from the first available resource, at index `0`.  (optional)

try:
    # List assessments
    api_response = api_instance.list_assessments(name=name, status=status, last_modified_from=last_modified_from, last_modified_until=last_modified_until, template_id=template_id, template_version=template_version, asset_id=asset_id, limit=limit, cursor=cursor)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AssessmentsApi->list_assessments: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to */rest/assessments/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AssessmentsApi* | [**conduct_assessment**](docs/AssessmentsApi.md#conduct_assessment) | **POST** /assessments/conduct | Conduct an assessment
*AssessmentsApi* | [**get_assessment**](docs/AssessmentsApi.md#get_assessment) | **GET** /assessments/{id} | Retrieve an assessment by ID
*AssessmentsApi* | [**get_assessment_by_assessment_review**](docs/AssessmentsApi.md#get_assessment_by_assessment_review) | **GET** /assessments/byAssessmentReview/{id} | Retrieve an assessment by assessment review ID
*AssessmentsApi* | [**list_assessments**](docs/AssessmentsApi.md#list_assessments) | **GET** /assessments | List assessments
*TemplatesApi* | [**list_templates**](docs/TemplatesApi.md#list_templates) | **GET** /templates | List templates

## Documentation For Models

 - [Answer](docs/Answer.md)
 - [Assessment](docs/Assessment.md)
 - [AssessmentStatus](docs/AssessmentStatus.md)
 - [Asset](docs/Asset.md)
 - [AssetType](docs/AssetType.md)
 - [AssetsAnswer](docs/AssetsAnswer.md)
 - [BaseAnswer](docs/BaseAnswer.md)
 - [BaseAsset](docs/BaseAsset.md)
 - [BaseGroup](docs/BaseGroup.md)
 - [BaseGroupAssignee](docs/BaseGroupAssignee.md)
 - [BaseTemplate](docs/BaseTemplate.md)
 - [BaseTypedUserOrGroupAssignee](docs/BaseTypedUserOrGroupAssignee.md)
 - [BaseUser](docs/BaseUser.md)
 - [BaseUserAssignee](docs/BaseUserAssignee.md)
 - [BaseUserOrGroupAssignee](docs/BaseUserOrGroupAssignee.md)
 - [BooleanAnswer](docs/BooleanAnswer.md)
 - [ConductAssessmentRequest](docs/ConductAssessmentRequest.md)
 - [DateAnswer](docs/DateAnswer.md)
 - [Group](docs/Group.md)
 - [GroupAssignee](docs/GroupAssignee.md)
 - [Item](docs/Item.md)
 - [ItemsAnswer](docs/ItemsAnswer.md)
 - [PagedAssessments](docs/PagedAssessments.md)
 - [PagedTemplates](docs/PagedTemplates.md)
 - [Question](docs/Question.md)
 - [QuestionAndAnswer](docs/QuestionAndAnswer.md)
 - [StandardErrorResponse](docs/StandardErrorResponse.md)
 - [Template](docs/Template.md)
 - [TextAnswer](docs/TextAnswer.md)
 - [User](docs/User.md)
 - [UserAssignee](docs/UserAssignee.md)
 - [UserOrGroupAssignee](docs/UserOrGroupAssignee.md)

## Documentation For Authorization


## basicAuth

- **Type**: HTTP basic authentication


## Author


