# coding: utf-8

"""
    Collibra Assessments API

    This API allows you to interact with the Assessments application in a programmatic way and perform actions such as retrieving data from conducted assessments or triggering new assessments.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PagedTemplates(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'next_cursor': 'str',
        'results': 'list[Template]'
    }

    attribute_map = {
        'next_cursor': 'nextCursor',
        'results': 'results'
    }

    def __init__(self, next_cursor=None, results=None):  # noqa: E501
        """PagedTemplates - a model defined in Swagger"""  # noqa: E501
        self._next_cursor = None
        self._results = None
        self.discriminator = None
        if next_cursor is not None:
            self.next_cursor = next_cursor
        self.results = results

    @property
    def next_cursor(self):
        """Gets the next_cursor of this PagedTemplates.  # noqa: E501

        The cursor pointing to the next page. If the cursor is missing, there are no additional pages of resources available after the current one.  # noqa: E501

        :return: The next_cursor of this PagedTemplates.  # noqa: E501
        :rtype: str
        """
        return self._next_cursor

    @next_cursor.setter
    def next_cursor(self, next_cursor):
        """Sets the next_cursor of this PagedTemplates.

        The cursor pointing to the next page. If the cursor is missing, there are no additional pages of resources available after the current one.  # noqa: E501

        :param next_cursor: The next_cursor of this PagedTemplates.  # noqa: E501
        :type: str
        """

        self._next_cursor = next_cursor

    @property
    def results(self):
        """Gets the results of this PagedTemplates.  # noqa: E501


        :return: The results of this PagedTemplates.  # noqa: E501
        :rtype: list[Template]
        """
        return self._results

    @results.setter
    def results(self, results):
        """Sets the results of this PagedTemplates.


        :param results: The results of this PagedTemplates.  # noqa: E501
        :type: list[Template]
        """
        if results is None:
            raise ValueError("Invalid value for `results`, must not be `None`")  # noqa: E501

        self._results = results

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PagedTemplates, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PagedTemplates):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
